#ifndef _MAINDLG_CPP
#define _MAINDLG_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <CommCtrl.H>
#include <ShlOBJ.H>
#include <Stdlib.H>
#include <Mmsystem.h>

#include "../Resources/Resource.H"

#include "../Source/NSWFL.H"
#include "../Source/Package.H"
#include "../Source/Entry.H"
#include "../Source/Common.H"
#include "../Source/DragDrop.H"

#include "../Dialogs/MainDlg.H"
#include "../Dialogs/ReadingDlg.H"
#include "../Dialogs/PackingDlg.H"
#include "../Dialogs/ExtractDlg.H"
#include "../Dialogs/OpenPassDlg.H"
#include "../Dialogs/NewPassDlg.H"
#include "../Dialogs/RegistrationDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---------------------(Variable Declarations)
HWND MainDialog_hWnd = NULL;
HWND FileList_hWnd = NULL;
HWND StatusBar_hWnd = NULL;

HIMAGELIST LV_MainDlgImageList = NULL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

HBRUSH BGColor = CreateSolidBrush( RGB(214, 211, 206) );

int SortCol = -1;
int SortUpOrDown = -1;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define IDM_NEW        1000
#define IDM_OPEN       1001
#define IDM_ADD        1002
#define IDM_DELETE     1003
#define IDM_EXTRACT    1004
#define IDM_VIEW       1005
#define IDM_PROPERTIES 1006
#define IDM_OPTIONS    1007
#define IDM_HELP       1008
#define IDM_EXIT       1009

#define ID_MYTOOLBAR   2000

#define BTIcons        10
#define TBButtons      13
#define TBLength       36
#define TBWidth        36

#define SORT_UP        1
#define SORT_DOWN      2

#define COL_STRING     1
#define COL_INTEGER    2
#define COL_DOUBLE     3
#define COL_DATE       4

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

TBBUTTON tbb[] = {
    {0, IDM_NEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
    {1, IDM_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},

    {0, 0, 0, TBSTYLE_SEP, 0, 0},

    {2, IDM_ADD, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
    {3, IDM_DELETE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
    {4, IDM_EXTRACT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},

    {0, 0, 0, TBSTYLE_SEP, 0, 0},

    {5, IDM_VIEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
    {6, IDM_PROPERTIES, 0, TBSTYLE_BUTTON, 0, 0},

    {0, 0, 0, TBSTYLE_SEP, 0, 0},

    {7, IDM_OPTIONS, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
    {8, IDM_HELP, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
    {9, IDM_EXIT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0}
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

HWND CreateToolBar(HWND hWnd)
{
    HWND hTool     = NULL;
    HBITMAP BitMap = NULL;

    InitCommonControls();

    if(! (BitMap = LoadBitmap(ghAppInstance, MAKEINTRESOURCE(IDB_TOOLBAR) )) )
        ErrorMessage(hWnd, "Failed to load bitmap");

    hTool = CreateToolbarEx(
        hWnd,
        WS_CHILD|WS_VISIBLE|TBSTYLE_TOOLTIPS|TBSTYLE_FLAT|TBSTYLE_TOOLTIPS|TBSTYLE_BUTTON,
        ID_MYTOOLBAR,
        BTIcons,
        NULL,
        (DWORD)BitMap,
        tbb,
        0,
        TBLength, TBWidth,
        TBLength, TBWidth,
        sizeof(TBBUTTON)
    );

	tbb[0].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM) "New");
    tbb[1].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM) "Open");

    tbb[3].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM) "Add");
    tbb[4].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM) "Delete");
    tbb[5].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM) "Extract");

    tbb[7].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM) "View");
    tbb[8].iString  = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM) "Properties");

    tbb[10].iString = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM) "Options");
    tbb[11].iString = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM) "Help");
    tbb[12].iString = SendMessage(hTool,(UINT)TB_ADDSTRING,(WPARAM)0,(LPARAM) "Exit");

    SendMessage(hTool, TB_ADDBUTTONS, TBButtons, (LONG)&tbb);
    SendMessage(hTool, TB_AUTOSIZE, 0, 0);

    return hTool;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int CALLBACK CompListEx(LPARAM lParam1, LPARAM lParam2, LPARAM lParam3)
{
    char buf1[MAX_PATH];
    char buf2[MAX_PATH];

    int RetVal = 0;

    SORTDATA *lpsd;

    lpsd = (SORTDATA *)lParam3;

    ListView_GetItemText(lpsd->hwndList, lParam1, (int)lpsd->isortSubItem, buf1, sizeof(buf1));
    ListView_GetItemText(lpsd->hwndList, lParam2, (int)lpsd->isortSubItem, buf2, sizeof(buf2));

    if(lpsd->iColType == COL_STRING)
    {
        RetVal = strcmpi(buf1, buf2);
    }
    else if(lpsd->iColType == COL_INTEGER)
    {
        int Val1 = iFormattedValue(buf1);
        int Val2 = iFormattedValue(buf2);

        if(Val1 > Val2)
            RetVal = 1;
        else if(Val1 < Val2)
            RetVal = -1;
        else return 0;
    }
    else if(lpsd->iColType == COL_DOUBLE)
    {
        double Val1 = fFormattedValue(buf1);
        double Val2 = fFormattedValue(buf2);

        if(Val1 > Val2)
            RetVal = 1;
        else if(Val1 < Val2)
            RetVal = -1;
        else return 0;
    }

    if(RetVal == 0)
        return 0;

    if(lpsd->iUPDOWN == SORT_DOWN)
    {
        if(RetVal == 1)
            return -1;
        else return 1;
    }
    else return RetVal;

    return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int CALLBACK CompList(LPARAM lParam1, LPARAM lParam2, LPARAM lParam3)
{
    int RetVal = 0;
    SORTDATA *lpsd;

    lpsd = (SORTDATA *)lParam3;

    if(lParam1 > lParam2)
        RetVal = 1;
    else if(lParam1 < lParam2)
        RetVal = -1;
    else return 0;

    if(lpsd->iUPDOWN == SORT_DOWN)
    {
        if(RetVal == 1)
            return -1;
        else return 1;
    }
    else return RetVal;

    return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
COleDataSource *OnGetClipboardData(BOOL bIncludeLink, LPPOINT lpOffset, LPSIZE lpSize)
{
	//ASSERT_VALID(this);

	COleDataSource *pDataSource = new COleDataSource;
	//TRY
	{
		//GetNativeClipboardData(pDataSource);
		//GetClipboardData(pDataSource, bIncludeLink, lpOffset, lpSize);
	}
	//CATCH_ALL(e)
	//{
		//delete pDataSource;
		//THROW_LAST();
	//}
	//END_CATCH_ALL

	//ASSERT_VALID(pDataSource);

	return pDataSource;
}
*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool DeletePostExecute(const char *sPath, const char *sParam)
{
	PROCESS_INFORMATION PI;
	STARTUPINFO SI;

	unsigned long ulExitCode = 0;

	DWORD dwDfltStrSz = 0;

	char sExe[MAX_PATH * 3];
	char sExeTmp[MAX_PATH * 3];
	char sExt[MAX_PATH];
	char sRegTemp[1024];
	char sFileAsso[1024];
	char sSystemRoot[1024];

	memset(sFileAsso, 0, sizeof(sFileAsso));

	_splitpath(sParam, NULL, NULL, NULL, sExt);

	dwDfltStrSz = sizeof(sFileAsso);
	memset(sFileAsso, 0, dwDfltStrSz);
	if(Get_StringRegistryValue(HKEY_CLASSES_ROOT, sExt, NULL, sFileAsso, dwDfltStrSz))
	{
		strcat(sFileAsso, "\\Shell");
		
		dwDfltStrSz = sizeof(sRegTemp);
		memset(sRegTemp, 0, dwDfltStrSz);
		if(!Get_StringRegistryValue(HKEY_CLASSES_ROOT, sFileAsso, NULL, sRegTemp, dwDfltStrSz))
		{
			//There is no default shell command.

			HKEY hKey = NULL;

			//Open the sExt\Shell key.
			if(RegOpenKeyEx(HKEY_CLASSES_ROOT, sFileAsso, 0, KEY_READ, &hKey) == ERROR_SUCCESS)
			{
				//Get the first key name.
				dwDfltStrSz = sizeof(sRegTemp);
				memset(sRegTemp, 0, dwDfltStrSz);
				if(RegEnumKeyEx(hKey, 0, sRegTemp, &dwDfltStrSz, NULL, NULL, NULL, NULL) == ERROR_SUCCESS)
				{
					RegCloseKey(hKey);
				}
				else{
					//There are no sub keys, there is no program associated with this sExt.
					RegCloseKey(hKey);
					return false;
				}
			}
		}

		if(strlen(sFileAsso) == 0)
		{
			return false;
		}

		strcat(sFileAsso, "\\");
		strcat(sFileAsso, sRegTemp);
		strcat(sFileAsso, "\\Command");

		dwDfltStrSz = sizeof(sExe);
		memset(sExe, 0, dwDfltStrSz);
		if(!Get_StringRegistryValue(HKEY_CLASSES_ROOT, sFileAsso, NULL, sFileAsso, dwDfltStrSz))
		{
			return false;
		}

		LCase(sFileAsso);

		Get_SystemDirectoryEx(sSystemRoot);
		
		ReplaceStrings(sFileAsso, "%systemroot%", sSystemRoot, sExeTmp);
		ReplaceStrings(sExeTmp, "%1", sParam, sExe);


	}

    //Set StartupInfo for the spawned process.
	GetStartupInfo(&SI);        

    SI.dwFlags     = STARTF_USESHOWWINDOW;
    SI.wShowWindow = SW_SHOWNORMAL;

	BOOL bResult = CreateProcess(NULL, sExe, NULL, NULL, TRUE, CREATE_SUSPENDED, NULL, sPath, &SI, &PI);

    if(bResult)
	{
		ResumeThread(PI.hThread);
        
		do
		{
			GetExitCodeProcess(PI.hProcess, &ulExitCode); 
			Sleep(1);
		}while(ulExitCode == STILL_ACTIVE);

	}

	DeleteFile(sParam); //FIXME: This should be a secure delete.

	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK MainDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HMENU SystemMenu = NULL;
    static HWND MainToolBar_hWnd = NULL;

    //--------------------------------------------------------------------------

    if(uMsg == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        MainDialog_hWnd = hWnd;

		SystemMenu = GetSystemMenu(hWnd, FALSE);
        AppendMenu(SystemMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(SystemMenu, MF_STRING, 1000, "About");

        SendMessage(hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)gsTitleCaption);
        SendMessage(hWnd, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)) );

        FileList_hWnd = GetDlgItem(hWnd, IDC_FILELIST);
        MainToolBar_hWnd = CreateToolBar(hWnd);

        SendMessage(FileList_hWnd, (UINT)LVM_SETEXTENDEDLISTVIEWSTYLE, (WPARAM)0, (LPARAM)LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT);
        ListView_SetTextColor(FileList_hWnd, RGB(0,0,100));

        LV_COLUMN MyLVColumb;

        memset(&MyLVColumb, 0, sizeof(LV_COLUMN));

        MyLVColumb.cx        = 200;
        MyLVColumb.pszText   = "Name";
        MyLVColumb.iSubItem  = 0;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(FileList_hWnd, 0, &MyLVColumb);

        MyLVColumb.cx        = 150;
        MyLVColumb.pszText   = "Type";
        MyLVColumb.iSubItem  = 1;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(FileList_hWnd, 1, &MyLVColumb);

        MyLVColumb.cx        = 125;
        MyLVColumb.pszText   = "Modified";
        MyLVColumb.iSubItem  = 2;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(FileList_hWnd, 2, &MyLVColumb);

        MyLVColumb.cx        = 65;
        MyLVColumb.pszText   = "Size";
        MyLVColumb.iSubItem  = 3;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_RIGHT;
        ListView_InsertColumn(FileList_hWnd, 3, &MyLVColumb);

        MyLVColumb.cx        = 50;
        MyLVColumb.pszText   = "Ratio";
        MyLVColumb.iSubItem  = 4;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(FileList_hWnd, 4, &MyLVColumb);

        MyLVColumb.cx        = 65;
        MyLVColumb.pszText   = "Packed";
        MyLVColumb.iSubItem  = 5;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_RIGHT;
        ListView_InsertColumn(FileList_hWnd, 5, &MyLVColumb);

        MyLVColumb.cx        = 75;
        MyLVColumb.pszText   = "CRC";
        MyLVColumb.iSubItem  = 6;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(FileList_hWnd, 6, &MyLVColumb);

        MyLVColumb.cx        = 75;
        MyLVColumb.pszText   = "Attributes";
        MyLVColumb.iSubItem  = 7;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(FileList_hWnd, 7, &MyLVColumb);

        MyLVColumb.cx        = 300;
        MyLVColumb.pszText   = "Path";
        MyLVColumb.iSubItem  = 8;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(FileList_hWnd, 8, &MyLVColumb);

        MyLVColumb.cx        = 0;
        MyLVColumb.pszText   = "Position";
        MyLVColumb.iSubItem  = 9;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(FileList_hWnd, 9, &MyLVColumb);

		LV_MainDlgImageList = ImageList_Create( GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), ILC_COLORDDB, 1, 100);
        ListView_SetImageList(FileList_hWnd, LV_MainDlgImageList, LVSIL_SMALL);

        StatusBar_hWnd = CreateStatusWindow(WS_CHILD|WS_VISIBLE, "Ready", hWnd, 1);

        int Widths[] = {200, -1};

        SendMessage(StatusBar_hWnd, (UINT)SB_SETPARTS, (WPARAM)2, (LPARAM)&Widths);

        CenterWindow(hWnd);

        RECT WindowRECT;
        GetClientRect(hWnd, &WindowRECT);
        MoveWindow(FileList_hWnd, 0, 70, WindowRECT.right, WindowRECT.bottom - 91, TRUE);
        MoveWindow(StatusBar_hWnd, WindowRECT.right-20, WindowRECT.bottom-20, WindowRECT.right, WindowRECT.bottom, TRUE);

		if(gdwCurrentJobType == JOB_TYPE_EXTRACTALL)
		{
            if(strlen(gsWorkingOutput) == 0)
			{
				if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_EXTRACT), hWnd, ExtractDialog) == 1)
				{
					hWorker_Thread_Handle = CreateThread(NULL, 0, ExtractEntireArchive_Worker_Thread, (LPVOID) gsArchiveName, CREATE_SUSPENDED, &dwWorker_Thread_ID);
					DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PACKING), hWnd, PackingDialog);
				}
			}
			else{
				hWorker_Thread_Handle = CreateThread(NULL, 0, ExtractEntireArchive_Worker_Thread, (LPVOID) gsArchiveName, CREATE_SUSPENDED, &dwWorker_Thread_ID);
				DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PACKING), hWnd, PackingDialog);
			}
		}
		else if(gdwCurrentJobType == JOB_TYPE_READING)
        {
            if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_READING), NULL, ReadingDialog) != 1)
            {
                ImageList_Destroy(LV_MainDlgImageList);
                EndDialog(hWnd, 0);
                DestroyWindow(hWnd);
            }
        }
        else if(gdwCurrentJobType == JOB_TYPE_PACKING_DIR || gdwCurrentJobType == JOB_TYPE_PACKING_FIL) {
            if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PACKING), NULL, PackingDialog) != 1)
            {
                ImageList_Destroy(LV_MainDlgImageList);
                EndDialog(hWnd, 0);
                DestroyWindow(hWnd);
            }
            else if(gbAutoClose == false) {
                // View an existing archive
                gdwCurrentJobType = JOB_TYPE_READING;
                hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) gsWorkingOutput, CREATE_SUSPENDED, &dwWorker_Thread_ID);
                if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_READING), hWnd, ReadingDialog) != 1)
                {
                    ImageList_Destroy(LV_MainDlgImageList);
                    EndDialog(hWnd, 0);
                    DestroyWindow(hWnd);
                }
                gbArchiveOpen = true;
            }
        }
        else{
            ResumeThread(hWorker_Thread_Handle);
        }

		if(gbAutoClose == true)
		{
            EndDialog(hWnd, 0);
            DestroyWindow(hWnd);			
			return false;
		}

        return TRUE; // Return TRUE to set the keyboard focus, Otherwise return FALSE
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_DROPFILES)
    {
		//This seems like alot of wasted memory, but we need it all.
		bool bFirstFile = true;

		char sDir[MAX_PATH];
		char DirTemp[MAX_PATH]; //Just some memory for AddFile() to use.
		char Drive[MAX_PATH];
		char sExt[MAX_PATH];
		char sFile[MAX_PATH];
		char sFileName[MAX_PATH]; 
		char sFirstRoot[MAX_PATH];
		char Root[MAX_PATH];
		char szFileName[MAX_PATH];

		FilePack MyFilePack;
		HDROP hFilesInfo = (HDROP)wParam;

		int wIndex = 0;
		int wTotalFiles = DragQueryFile(hFilesInfo, -1, NULL, 0);

		//Save the name of the first sFile in szFileName, it will be overwritten.
		DragQueryFile(hFilesInfo, wIndex, (LPSTR)szFileName, MAX_PATH);

		if(wTotalFiles == 1)
		{
			_splitpath(szFileName, NULL, NULL, NULL, sExt);

			if(strcmpi(sExt, ".PCE") == 0)
			{
				strcpy(gsArchiveName, szFileName);

				// View an existing archive
                gdwCurrentJobType = JOB_TYPE_READING;
                if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_OPENPASS), hWnd, OpenPassDialog) != 1)
                {
                    return TRUE;
                }

                ShowWindow(hWnd, SW_HIDE);
                ListView_DeleteAllItems(FileList_hWnd);
                hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) gsArchiveName, CREATE_SUSPENDED, &dwWorker_Thread_ID);
                if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_READING), hWnd, ReadingDialog) != 1)
                {
                    ListView_DeleteAllItems(FileList_hWnd);
                }
                ShowWindow(hWnd, SW_SHOW);

				return TRUE;
			}
		}

		if(gbArchiveOpen)
		{
			strcpy(gsWorkingOutput, gsArchiveName);
		}
		else {
			if(MessageBox(hWnd, "Would you like to create a new archive?", gsTitleCaption, MB_YESNO|MB_ICONQUESTION) == IDNO)
			{
				return TRUE;
			}

            // Create a new archive from the directorys contents
            if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_NEWPASS), NULL, NewPassDialog) != 1)
            {
                return TRUE;
            }
		}

		MyFilePack.Initialize(&AltFilePackage);

        while(wIndex < wTotalFiles)
        {
            DragQueryFile(hFilesInfo, wIndex, (LPSTR)szFileName, MAX_PATH);

			if(IsDirectory(szFileName))
			{
				bool bRecursive = false;
				char sMsg[1024];

				sprintf(sMsg, "Process all sub directorys that the folder contains?\r\n\"%s\"", szFileName);
				int iMBResult = MessageBox(hWnd, sMsg, gsTitleCaption, MB_YESNOCANCEL|MB_ICONQUESTION);
				if(iMBResult == IDCANCEL){
					return TRUE;
				}
				else if(iMBResult == IDYES){
					bRecursive = true;
				}
				else if(iMBResult == IDNO){
					bRecursive = false;
				}

				MyFilePack.IndexDirectoryEx(szFileName, bRecursive, NULL, &AltFilePackage);
				strcpy(sFirstRoot, szFileName);
			}
			else{
				_splitpath(szFileName, Drive, sDir, sFile, sExt);
				_makepath(Root, Drive, sDir, NULL, NULL);

				if(bFirstFile)
				{
					strcpy(sFirstRoot, Root);
					bFirstFile = false;
				}

				_makepath(sFileName, NULL, NULL, sFile, sExt);

				int RootLen = strlen(Root);

				MyFilePack.AddFile(Root, RootLen, DirTemp, RootLen, sFileName, &AltFilePackage);
			}

            wIndex++;
        }

		if(AltFilePackage.dwFileCount > 0)
		{
			gdwCurrentJobType = JOB_TYPE_ADDINGFILES;
			hWorker_Thread_Handle = CreateThread(NULL, 0, AddFiles_Worker_Thread, (LPVOID) sFirstRoot, CREATE_SUSPENDED, &dwWorker_Thread_ID);
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PACKING), hWnd, PackingDialog);

			// View an existing archive
			gdwCurrentJobType = JOB_TYPE_READING;
			hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) gsWorkingOutput, CREATE_SUSPENDED, &dwWorker_Thread_ID);
			if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_READING), hWnd, ReadingDialog) != 1)
			{
				ImageList_Destroy(LV_MainDlgImageList);
				EndDialog(hWnd, 0);
				DestroyWindow(hWnd);
			}
		}

		DragFinish(hFilesInfo);
		MyFilePack.FreeMemory(&AltFilePackage);

        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CTLCOLORDLG)
        return (LONG)BGColor;

    //--------------------------------------------------------------------------

    if(uMsg == WM_SIZE)
    {
        int nWidth = LOWORD(lParam);
        int nHeight = HIWORD(lParam);

        MoveWindow(FileList_hWnd, 0, 70, nWidth, nHeight - 91, TRUE);
        MoveWindow(StatusBar_hWnd, nWidth-20, nHeight-20, nWidth, nHeight, TRUE);

        SendMessage(MainToolBar_hWnd, TB_AUTOSIZE, 0, 0);

        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_COMMAND)
    {
		if(wParam == ID_HELP_ENTERREGISTRATIONCODE)
        {
			if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_REGISTRATION), hWnd, RegistrationDialog) == 1)
			{
			
			}
			return TRUE;
		}
		
		if(wParam == IDM_ADD)
        {
			MsgBox("Not Implemented.");
			return TRUE;
		}

		if(wParam == IDM_DELETE)
        {
			MsgBox("Not Implemented.");
			return TRUE;
		}

		if(wParam == IDM_VIEW)
        {
/*7
			int iLVItemPos = -1;

			char sTempExtractLocation[MAX_PATH];
			char sFilePath[MAX_PATH + 1];
			char sFileName[MAX_PATH + 1];
			char sFullPath[MAX_PATH + 1];
			char sFullFile[MAX_PATH + 1];

			strcpy(sTempExtractLocation, gsExtractLocation);

			Get_TempDirectoryEx(gsExtractLocation);
			
			gdwCurrentJobType = JOB_TYPE_EXTRACTSEL;
			hWorker_Thread_Handle = CreateThread(NULL, 0, ExtractEntireArchive_Worker_Thread, (LPVOID) gsArchiveName, CREATE_SUSPENDED, &dwWorker_Thread_ID);
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PACKING), hWnd, PackingDialog);

			while((iLVItemPos = ListView_GetNextItem(FileList_hWnd, iLVItemPos, LVNI_SELECTED)) != -1)
            {
                ListView_GetItemText(FileList_hWnd, iLVItemPos, 0, sFileName, MAX_PATH);
                ListView_GetItemText(FileList_hWnd, iLVItemPos, 8, sFilePath, MAX_PATH);

				sprintf(sFullPath, "%s\\%s", gsExtractLocation, sFilePath);
				CorrectReversePath(sFullPath);

				sprintf(sFullFile, "%s\\%s", sFullPath, sFileName);
				CorrectReversePath(sFullFile);

				ShowWindow(hWnd, SW_MINIMIZE);
				DeletePostExecute(sFullPath, sFullFile);
				ShowWindow(hWnd, SW_NORMAL);
			}

			strcpy(gsExtractLocation, sTempExtractLocation);
			*/

			MsgBox("Not Implemented.");
			return TRUE;
		}

		if(wParam == IDM_PROPERTIES)
        {
			MsgBox("Not Implemented.");
			return TRUE;
		}

		if(wParam == IDM_OPTIONS)
        {
			MsgBox("Not Implemented.");
			return TRUE;
		}

		if(wParam == IDM_HELP || wParam == ID_HELP_CONTENTS)
        {
			MsgBox("Not Implemented.");
			return TRUE;
		}
		
		if(wParam == IDM_NEW || wParam == ID_FILE_FNEW)
        {
            PlaySound(MAKEINTRESOURCE(IDR_TICKWAVE), ghAppInstance, SND_ASYNC|SND_RESOURCE);

            gbArchiveOpen = false;

            gdwCurrentJobType = 0;

            memset(gsArchiveName, 0, sizeof(gsArchiveName));
            memset(gsLastExtractLocation, 0, sizeof(gsLastExtractLocation));
            memset(gsWorkingOutput, 0, sizeof(gsWorkingOutput));

            ListView_DeleteAllItems(FileList_hWnd);

            return TRUE;
        }

        if(wParam == IDM_OPEN || wParam == ID_FILE_FOPEN)
        {
            PlaySound(MAKEINTRESOURCE(IDR_TICKWAVE), ghAppInstance, SND_ASYNC|SND_RESOURCE);

            char *DefaultExtension = NULL;
            char *Filters = "Project-Epsilon-Files\0*.PCE\0All-Files\0*.*\0\0";
            char InitialDirectory[MAX_PATH + 1];

            GetCurrentDirectory(MAX_PATH, InitialDirectory);

            if(OSFileDialog(hWnd, gsArchiveName, ".PCE", "Select an archive to open", Filters, InitialDirectory, OFD, OFN_EXPLORER + OFN_LONGNAMES + OFN_PATHMUSTEXIST))
            {
                // View an existing archive
                gdwCurrentJobType = JOB_TYPE_READING;
                if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_OPENPASS), hWnd, OpenPassDialog) != 1)
                {
                    return TRUE;
                }

                ShowWindow(hWnd, SW_HIDE);
                ListView_DeleteAllItems(FileList_hWnd);
                hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) gsArchiveName, CREATE_SUSPENDED, &dwWorker_Thread_ID);
                if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_READING), hWnd, ReadingDialog) != 1)
                {
                    ListView_DeleteAllItems(FileList_hWnd);
                }
                ShowWindow(hWnd, SW_SHOW);
            }

            return TRUE;
        }

        if(wParam == IDM_EXTRACT)
        {
            PlaySound(MAKEINTRESOURCE(IDR_TICKWAVE), ghAppInstance, SND_ASYNC|SND_RESOURCE);

            if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_EXTRACT), hWnd, ExtractDialog) == 1)
            {
                hWorker_Thread_Handle = CreateThread(NULL, 0, ExtractEntireArchive_Worker_Thread, (LPVOID) gsArchiveName, CREATE_SUSPENDED, &dwWorker_Thread_ID);
                DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PACKING), hWnd, PackingDialog);
            }

            return TRUE;
        }

		/*
        if(wParam == IDM_HELP)
        {
            PlaySound(MAKEINTRESOURCE(IDR_TICKWAVE), ghAppInstance, SND_ASYNC|SND_RESOURCE);

            int Value = ListView_GetSelectedCount(FileList_hWnd);

            int ItemPos = -1;
            while( (ItemPos = ListView_GetNextItem(FileList_hWnd, ItemPos, LVNI_SELECTED)) != -1)
            {
                char sFileName[255 + 1];
                char sFullFileName[255 + 1];
                char Path[255 + 1];

                ListView_GetItemText(FileList_hWnd, ItemPos, 0, sFileName, 255);
                ListView_GetItemText(FileList_hWnd, ItemPos, 8, Path, 255);

                _makepath(sFullFileName, NULL, Path, sFileName, NULL);

                MessageBox(hWnd, sFullFileName, Path, 0);
            }

            return TRUE;
        }
		*/

        if(wParam == IDM_EXIT || wParam == ID_FILE_EXIT)
        {
            PlaySound(MAKEINTRESOURCE(IDR_TICKWAVE), ghAppInstance, SND_ASYNC|SND_RESOURCE);

            ImageList_Destroy(LV_MainDlgImageList);
            EndDialog(hWnd, 0);
            DestroyWindow(hWnd);
            return TRUE;
        }

        if(wParam == ID_HELP_ABOUT)
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = hWnd;

            NetLogo(&ADI);
			return TRUE;
		}

		return FALSE;
    }

    //--------------------------------------------------------------------------

	if(uMsg == WM_NOTIFY)
    {
        LPNMHDR lpnmhdr = (LPNMHDR)lParam;

		if (lpnmhdr->hwndFrom == FileList_hWnd)
        {
            int iSortSubItem = 0;
            LVCOLUMN MyLVColumn;
            NMLISTVIEW  *pNMLV;
            SORTDATA SortData;
			int iIndex = 0;
            char ColName[64];

            if(lpnmhdr->code == NM_DBLCLK)
            {
                MsgBox("Not Implemented.");

				iIndex = ListView_GetNextItem(FileList_hWnd, -1, LVNI_SELECTED);
                MessageBox(hWnd, IntChar(iIndex), gsTitleCaption, 0);
			}
			else if(lpnmhdr->code == LVN_BEGINDRAG)
			{
                MsgBox("Not Implemented.");
				/*
				pNMLV = (NMLISTVIEW *)lParam;
				COleDataSource MyOleDS;

				MyOleDS.

				
				BeginDrag(1, 1, 1);
				iSortSubItem = pNMLV->iSubItem;
				MsgBox("LVN_BEGINDRAG");
				*/
			}
			else if(lpnmhdr->code == LVN_COLUMNCLICK)
			{
                pNMLV = (NMLISTVIEW *)lParam;
                iSortSubItem = pNMLV->iSubItem;

                memset(&SortData, 0, sizeof(SortData));
                memset(&MyLVColumn, 0, sizeof(&MyLVColumn));

                if(SortCol == iSortSubItem)
                {
                    if(SortUpOrDown == SORT_UP)
                        SortUpOrDown = SORT_DOWN;
                    else SortUpOrDown = SORT_UP;
                }
                else {
                    SortCol = iSortSubItem;
                    SortUpOrDown = SORT_UP;
                }

                SortData.hwndList = FileList_hWnd;
                SortData.isortSubItem = SortCol;
                SortData.iUPDOWN = SortUpOrDown;

                MyLVColumn.mask = LVCF_TEXT;
                MyLVColumn.pszText = ColName;
                MyLVColumn.cchTextMax = sizeof(ColName);

                if(ListView_GetColumn(FileList_hWnd, iSortSubItem, &MyLVColumn))
                {
                    if(strcmpi(ColName, "Name") == 0)
                        SortData.iColType = COL_STRING;
                    else if(strcmpi(ColName, "Type") == 0)
                        SortData.iColType = COL_STRING;
                    else if(strcmpi(ColName, "Modified") == 0)
                        SortData.iColType = COL_DATE;
                    else if(strcmpi(ColName, "Size") == 0)
                        SortData.iColType = COL_INTEGER;
                    else if(strcmpi(ColName, "Packed") == 0)
                        SortData.iColType = COL_INTEGER;
                    else if(strcmpi(ColName, "Ratio") == 0)
                        SortData.iColType = COL_DOUBLE;
                    else if(strcmpi(ColName, "CRC") == 0)
                        SortData.iColType = COL_STRING;
                    else if(strcmpi(ColName, "Attributes") == 0)
                        SortData.iColType = COL_STRING;
                    else if(strcmpi(ColName, "Path") == 0)
                        SortData.iColType = COL_STRING;
                    else if(strcmpi(ColName, "Position") == 0)
                        SortData.iColType = COL_INTEGER;
                    else SortData.iColType = 0;

                    if(SortData.iColType == COL_DATE)
                    {
                        ListView_SortItems(FileList_hWnd, CompList, (LPARAM)&SortData);
                    }
                    else if(SortData.iColType != 0)
                    {
                        ListView_SortItemsEx(FileList_hWnd, CompListEx, (LPARAM)&SortData);
                    }
				}
			}
        }
        return TRUE;
    }

    //--------------------------------------------------------------------------

	if(uMsg == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(hWnd, &ThisPS);

        // Any painting should be done here

        EndPaint(hWnd, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_SYSCOMMAND) // Received A System Menu Message
    {
        if(LOWORD(wParam) == 1000) //- About (SysMenu Command)
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = hWnd;

            NetLogo(&ADI);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CLOSE)  // Received Close Message
    {
        ImageList_Destroy(LV_MainDlgImageList);
        EndDialog(hWnd,0);
        DestroyWindow(hWnd);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

