#ifndef _OPENPASSDLG_CPP
#define _OPENPASSDLG_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <ShlOBJ.H>
#include <Stdlib.H>

#include "../Resources/Resource.H"

#include "../Source/NSWFL.H"
#include "../Source/Package.H"
#include "../Source/Entry.H"
#include "../Source/Common.H"

#include "../Dialogs/MainDlg.H"
#include "../Dialogs/OpenPassDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---------------------(Variable Declarations)
HWND OpenPassDialog_hWnd = NULL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK OpenPassDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HMENU SystemMenu = NULL;

    static HWND Password_hWnd = NULL;
    static HWND PasswordBitsBar_hWnd = NULL;
    static HWND PasswordBits_hWnd    = NULL;

    //--------------------------------------------------------------------------

    if(uMsg == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        OpenPassDialog_hWnd = hWnd;

        SystemMenu = GetSystemMenu(hWnd, FALSE);
        AppendMenu(SystemMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(SystemMenu, MF_STRING, 1000, "About");

        SendMessage(hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)gsTitleCaption);
        SendMessage(hWnd, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)) );

        Password_hWnd = GetDlgItem(hWnd, IDC_PASSWORD);
        PasswordBitsBar_hWnd = GetDlgItem(hWnd, IDC_PASSWORDBAR1);
        PasswordBits_hWnd = GetDlgItem(hWnd, IDC_PASSWORDBITS1);

        SendMessage(Password_hWnd, EM_LIMITTEXT, 1024, 0 );

        Set_Text(Password_hWnd, gsPassword);
		Set_Text(Password_hWnd, "11111111");

        CenterWindow(hWnd);

        return TRUE; // Return TRUE to set the keyboard focus, Otherwise return FALSE
    }

    //--------------------------------------------------------------------------

    if(uMsg == 307) // Key Down
    {
        float PasswordLen    = 0;
        float EffeciencyBits = 0;

        char lsTemp0[64];
        char lsTemp1[64];

        PasswordLen = (float) SendMessage(Password_hWnd, WM_GETTEXTLENGTH, 0, 0);

        EffeciencyBits = (PasswordLen / 56) * 100;
        SendMessage(PasswordBitsBar_hWnd, PBM_SETPOS, (int) EffeciencyBits, 0);

        sprintf(lsTemp0," (%s Bits)", FormatInteger(lsTemp1, (long)(PasswordLen * 8)));
        Set_Text(PasswordBits_hWnd, lsTemp0);
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_COMMAND)
    {
        if(wParam == IDC_OK)
        {
            int iLength = Get_TextEx(Password_hWnd, gsPassword, 1024);
            if(iLength < 8 || iLength > 1024)
            {
                MessageBox(hWnd, "Please enter a password. Within 8 and 1,024 characters.", gsTitleCaption, 0);
                return TRUE;
            }

            EndDialog(hWnd, 1);
            return TRUE;
        }

        if(wParam == IDC_CANCEL)
        {
            EndDialog(hWnd, 0);
            DestroyWindow(hWnd);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

	if(uMsg == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(hWnd, &ThisPS);

        // Any painting should be done here

        EndPaint(hWnd, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_SYSCOMMAND) // Received A System Menu Message
    {
        if(LOWORD(wParam) == 1000) //- About (SysMenu Command)
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = hWnd;

            NetLogo(&ADI);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CLOSE)  // Received Close Message
    {
        EndDialog(hWnd, 0);
        DestroyWindow(hWnd);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

