#ifndef _RegistrationDLG_CPP
#define _RegistrationDLG_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <ShlOBJ.H>
#include <Stdlib.H>

#include "../Resources/Resource.H"

#include "../Source/NSWFL.H"
#include "../Source/Package.H"
#include "../Source/Entry.H"
#include "../Source/Common.H"

#include "../Dialogs/MainDlg.H"
#include "../Dialogs/RegistrationDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---------------------(Variable Declarations)
HWND RegistrationDialog_hWnd = NULL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DWORD CheckReg_Thread_ID = 0;
HANDLE CheckReg_Thread_Handle = NULL;

char sUserCode[1024];

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI CheckReg_Thread(LPVOID lpData)
{
	if(ValidateRegCode((unsigned char *)sUserCode))
	{
		EndDialog(RegistrationDialog_hWnd, 1);
	}
	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK RegistrationDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HMENU SystemMenu = NULL;

	static HWND RegCode_hWnd = NULL;

    //--------------------------------------------------------------------------

    if(uMsg == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        RegistrationDialog_hWnd = hWnd;

        SystemMenu = GetSystemMenu(hWnd, FALSE);
        AppendMenu(SystemMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(SystemMenu, MF_STRING, 1000, "About");

        SendMessage(hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)gsTitleCaption);
        SendMessage(hWnd, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)) );

        RegCode_hWnd = GetDlgItem(hWnd, IDC_REGCODE);

        SendMessage(RegCode_hWnd, EM_LIMITTEXT, 30, 0);

		//Set_Text(RegCode_hWnd, "AAAAA");

        CenterWindow(hWnd);

		return TRUE; // Return TRUE to set the keyboard focus, Otherwise return FALSE
    }

	//--------------------------------------------------------------------------

    if(uMsg == WM_COMMAND)
    {
        if(wParam == IDC_OK)
        {
			if(Get_TextEx(RegCode_hWnd, sUserCode, sizeof(sUserCode)) <= 25)
			{
				MessageBox(hWnd, "Please enter the full registration code.", gsTitleCaption, 0);
				SetFocus(RegCode_hWnd);
				return TRUE;
			}
			else{
				CheckReg_Thread_Handle = CreateThread(NULL, 0, CheckReg_Thread, (LPVOID)0, 0, &CheckReg_Thread_ID);
			}

            return TRUE;
        }

        if(wParam == IDC_CANCEL)
        {
	        EndDialog(hWnd, 0);
            return TRUE;
        }

		return FALSE;
    }

    //--------------------------------------------------------------------------

	if(uMsg == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(hWnd, &ThisPS);

        // Any painting should be done here

        EndPaint(hWnd, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_SYSCOMMAND) // Received A System Menu Message
    {
        if(LOWORD(wParam) == 1000) //- About (SysMenu Command)
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = hWnd;

            NetLogo(&ADI);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CLOSE)  // Received Close Message
    {
        EndDialog(hWnd, 0);
        DestroyWindow(hWnd);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

